#[doc = "Register `TRIM2` reader"]
pub struct R(crate::R<TRIM2_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<TRIM2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<TRIM2_SPEC>> for R {
    fn from(reader: crate::R<TRIM2_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `TRIM2` writer"]
pub struct W(crate::W<TRIM2_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<TRIM2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<TRIM2_SPEC>> for W {
    fn from(writer: crate::W<TRIM2_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `IDAC1_SNK_TRIM` reader - IDAC1 trim bits for gain control in current sink mode"]
pub struct IDAC1_SNK_TRIM_R(crate::FieldReader<u8, u8>);
impl IDAC1_SNK_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        IDAC1_SNK_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for IDAC1_SNK_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `IDAC1_SNK_TRIM` writer - IDAC1 trim bits for gain control in current sink mode"]
pub struct IDAC1_SNK_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> IDAC1_SNK_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | (value as u32 & 0x0f);
        self.w
    }
}
#[doc = "Field `IDAC2_SNK_TRIM` reader - IDAC2 trim bits for gain control in current sink mode"]
pub struct IDAC2_SNK_TRIM_R(crate::FieldReader<u8, u8>);
impl IDAC2_SNK_TRIM_R {
    pub(crate) fn new(bits: u8) -> Self {
        IDAC2_SNK_TRIM_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for IDAC2_SNK_TRIM_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `IDAC2_SNK_TRIM` writer - IDAC2 trim bits for gain control in current sink mode"]
pub struct IDAC2_SNK_TRIM_W<'a> {
    w: &'a mut W,
}
impl<'a> IDAC2_SNK_TRIM_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 4)) | ((value as u32 & 0x0f) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - IDAC1 trim bits for gain control in current sink mode"]
    #[inline(always)]
    pub fn idac1_snk_trim(&self) -> IDAC1_SNK_TRIM_R {
        IDAC1_SNK_TRIM_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:7 - IDAC2 trim bits for gain control in current sink mode"]
    #[inline(always)]
    pub fn idac2_snk_trim(&self) -> IDAC2_SNK_TRIM_R {
        IDAC2_SNK_TRIM_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - IDAC1 trim bits for gain control in current sink mode"]
    #[inline(always)]
    pub fn idac1_snk_trim(&mut self) -> IDAC1_SNK_TRIM_W {
        IDAC1_SNK_TRIM_W { w: self }
    }
    #[doc = "Bits 4:7 - IDAC2 trim bits for gain control in current sink mode"]
    #[inline(always)]
    pub fn idac2_snk_trim(&mut self) -> IDAC2_SNK_TRIM_W {
        IDAC2_SNK_TRIM_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "CSD Trim Register\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [trim2](index.html) module"]
pub struct TRIM2_SPEC;
impl crate::RegisterSpec for TRIM2_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [trim2::R](R) reader structure"]
impl crate::Readable for TRIM2_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [trim2::W](W) writer structure"]
impl crate::Writable for TRIM2_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets TRIM2 to value 0"]
impl crate::Resettable for TRIM2_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
